<template>
    <div class="container">
        <div class="row">
            <div class="col-6">
                <auto-complete 
                    v-model="data.selected" 
                    :elements="data.elements" 
                    :initKey="data.initKey"
                    placeholder="Elementos" 
                    :minLength="2" 
                    :disabled="false"
                    :required="true"
                />
            </div>
            <div class="col-12"><h3>Elemento seleccionado: </h3><br>{{ data.selected }}</div>
            <div class="col-12">
                <label>InitKey test:</label><br>
                <input v-model="data.initKey">
            </div>
        </div>
        {{ test }}
    </div>
</template>
  
<script setup lang="ts">
import { reactive, onMounted, inject } from "vue";
import { AutoComplete, AutocompleteElement, navbarKey } from "../../../src/index";

class Example extends AutocompleteElement {
    id_example: number;
    nombre: string;
    nombre2: string;
    dato_adicional: string;

    constructor(
        id_example: number,
        nombre: string,
        nombre2: string,
        dato_adicional: string,
    ){
        super();
        this.id_example = id_example;
        this.nombre = nombre;
        this.nombre2 = nombre2;
        this.dato_adicional = dato_adicional;
    }

    public get key(): string {
        return this.id_example +  this.dato_adicional;
    }
    public get value(): string {
        return this.nombre + " " + this.nombre2;
    }

}
const test = inject(navbarKey);

const emit = defineEmits(['changeBreadCrumbRoutes']);

const data = reactive({
    elements: [
        new Example(1 , "dato1", "apellido1", "test-9"),
        new Example(2 , "dato2", "apellido2", "test-3"),
        new Example(3 , "dato3", "apellido3", "test-2"),
        new Example(4 , "prueba4", "nombre4", "test-1"),
        new Example(5 , "prueba5", "nombre5", "test-0"),
        new Example(6 , "prueba6", "nombre6", "test-5"),
        new Example(7 , "fede", "rico1", "test-7"),
        new Example(8 , "fede", "rico2", "test-2"),
        new Example(9 , "fede", "rico3", "test-6"),
        new Example(10 , "fedeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee", "ricooooooooooooooooooooooooooooooooooo4", "test-7")
    ] as Example[],
    selected: null as Example,
    initKey: null as number | string | null,
});

onMounted(() => {
    let routes = [
        { name: "inicio" },
        { name: "autocomplete" },
    ];
    emit("changeBreadCrumbRoutes", routes);
});

</script>

<style></style>
  